<div align="center">
<h1>use-haki</h1>

<a href="https://github.com/olafsulich/use-haki/settings">
  <img
    height="80"
    width="80"
    alt="fish"
    src="https://i.ibb.co/SmkHMr2/fishhook.png"
  />
</a>

<p>React hooks library</p>

<br />

[**Contributing**](./CONTRIBUTING.md) | [**Code of Conduct**](./CODE_OF_CONDUCT.md) | [**Docs**](./docs)

<br />
</div>

<hr />

<!-- prettier-ignore-start -->
[![Build Status](https://img.shields.io/circleci/build/github/olafsulich/use-haki/master?style=flat-square)](https://app.circleci.com/pipelines/github/olafsulich/use-haki)
[![npm](https://img.shields.io/npm/v/use-haki?style=flat-square)](https://www.npmjs.com/package/use-haki)
[![downloads](https://img.shields.io/npm/dm/use-haki?style=flat-square)](https://www.npmtrends.com/use-haki)
[![GitHub license](https://img.shields.io/github/license/olafsulich/use-haki.svg?style=flat-square)](https://github.com/olafsulich/usehaki/blob/master/LICENSE)

[![PRs Welcome](https://img.shields.io/badge/PRs-welcome-brightgreen.svg?style=flat-square)](http://makeapullrequest.com)
[![Code of Conduct](https://img.shields.io/badge/code%20of-conduct-ff69b4.svg?style=flat-square)](https://github.com/testing-library/react-hooks-testing-library/blob/master/CODE_OF_CONDUCT.md)

[![Star on GitHub](https://img.shields.io/github/stars/olafsulich/use-haki.svg?style=social)](https://github.com/olafsulich/use-haki/stargazers)

<!-- prettier-ignore-end -->

<div align="center">
  <br />
  <br />
  <pre>npm i <a href="https://www.npmjs.com/package/use-haki">use-haki</a></pre>
  <br />
  <br />
</div>

## Hooks

- [`useClickOutside`](./docs/useClickOutside.md) &mdash; allows you to detect clicks outside of a specified element.

- [`useEventListener`](./docs/useEventListener.md) &mdash; provide a declarative hook for events listeners.

- [`useFetch`](./docs/useFetch.md) &mdash; hook for fetch requests.

- [`useGeoPosition`](./docs/useGeoPosition.md) &mdash; gives device current location.

- [`useHelloRomanJoke`](./docs/useHelloRomanJoke.md) &mdash; fetch random [Hello Roman](https://www.youtube.com/channel/UCq8XmOMtrUCb8FcFHQEd8_g) joke.

- [`useHover`](./docs/useHover.md) &mdash; detect mouse move on a specified element.

- [`useIdle`](./docs/useIdle.md) &mdash; tracks if user on the page is idle.

- [`useInterval`](./docs/useInterval.md) &mdash; provides setInterval in react hook.

- [`useKeyPress`](./docs/useKeyPress.md) &mdash; detect when user is pressing a specific key.

- [`useLocalStorage`](./docs/useLocalStorage.md) &mdash; manage your local storage in easy way.

- [`useMousePosition`](./docs/useMousePosition.md) &mdash; tracks mouse position.

- [`usePageWidth`](./docs/usePageWidth.md) &mdash; gives current page width.

- [`useScrollPosition`](./docs/useScrollPosition.md) &mdash; tracks scroll position.

- [`useToggle`](./docs/useToggle.md) &mdash; tracks toggle state.

- [`useUnsplash`](./docs/useUnsplash.md) &mdash; gives random image from [Unsplash](https://unsplash.com/).

- [`useDateTimeFormat`](./docs/useDateTimeFormat.md) &mdash; enable language-sensitive date formatting

- [`usePluralRules`](./docs/usePluralRules.md) &mdash; find ordinal for given number

- [`useIntersection`](./docs/useIntersection.md) &mdash; use intersection observer listener in an easy way

- [`useMeasure`](./docs/useMeasure.md) &mdash; gives sizes of an element and its position

  <br />

## Technologies

- React
- TypeScript
- Microbundle
- CircleCI
- Eslint & Prettier
- Husky & Lint-staged
- React Testing Library & React Hooks Testing Library
- Github Actions

  <br />

## Contributors

Thanks goes to these wonderful people ([emoji key](https://allcontributors.org/docs/en/emoji-key)):

<!-- ALL-CONTRIBUTORS-LIST:START - Do not remove or modify this section -->
<!-- prettier-ignore-start -->
<!-- markdownlint-disable -->
<table>
  <tr>
    <td align="center"><a href="http://frontlive.pl"><img src="https://avatars1.githubusercontent.com/u/46969484?v=4" width="100px;" alt=""/><br /><sub><b>Olaf Sulich</b></sub></a></td>
  </tr>
</table>

<!-- markdownlint-enable -->
<!-- prettier-ignore-end -->

<!-- ALL-CONTRIBUTORS-LIST:END -->

This project follows the [all-contributors](https://allcontributors.org/) specification.
Contributions of any kind welcome!

## Issues

_Looking to contribute? Look for the
[Good First Issue](https://github.com/olafsulich/use-haki/issues?utf8=✓&q=is%3Aissue+is%3Aopen+sort%3Areactions-%2B1-desc+label%3A"good+first+issue"+)
label._

### 🐛 Bugs

Please file an issue for bugs, missing documentation, or unexpected behavior.

[**See Bugs**](https://github.com/olafsulich/use-haki/issues?q=is%3Aissue+is%3Aopen+label%3Abug+sort%3Acreated-desc)

### 💡 Feature Requests

Please file an issue to suggest new features/hooks. Vote on feature requests by adding a 👍. This helps
me prioritize what to work on.

[**See Feature Requests**](https://github.com/olafsulich/use-haki/issues?q=is%3Aissue+sort%3Areactions-%2B1-desc+label%3Aenhancement+is%3Aopen)

### ❓ Questions

For questions related to using the library, you can
[raise issue here](https://github.com/olafsulich/use-haki/issues/new), or
send me an email: **olafsulich@gmail.com**

  <br />
