import { RefObject } from 'react';
declare enum Events {
    MOUSEDOWN = "mousedown",
    TOUCHSTART = "touchstart"
}
declare type EventsTypes = [typeof Events.MOUSEDOWN, typeof Events.TOUCHSTART][number];
declare type Event = {
    [Type in EventsTypes]: HTMLElementEventMap[Type];
}[EventsTypes];
declare type Ref = RefObject<HTMLElement>;
declare type Handler = (event: Event) => void;
declare const useClickOutside: (ref: Ref, handler: Handler) => void;
export default useClickOutside;
